//=============================================================================
// SRpack2Coop.
//=============================================================================
class SRpack2Coop expands CoopGame;
//	config(SRpack2_Settings);

// SUBGAMETIME STUFF -------

// the actual subgametype
var(SpecialGameTypes) config enum eSGT
{
Classic,
RocketFrenzy,
DeathMatch,
HardCore//, 
//InstaGib not done yet
} SubGameType;
var(SpecialGameTypes) config bool EnableSubGametypes;


var string sSGT; // replicated subgametype string for the scoreboard

// time before checking the subgametype again
//var() config int ReCheckDelay;

// --------------------------



// MESSAGE STUFF ------------

var(Messaging) config string Messages[30];
var(Messaging) config int MessageDelay;
var(Messaging) config bool EnableMessageAdds;
var int MessageAmount;
// --------------------------

// MAP CHANGE STUFF ---------

var(LobbyMode) config bool LobbyModeEnabled;
var(LobbyMode) config string EndMaps[20];
var(LobbyMode) config string LobbyMap;


// ADMINISTRATION STUFF -----
var actor MuteList[100];


// INGAME MAPFIX STUFF ------
struct sMapFix
{
	var() string a_MapName;
	var() enum MFCMD
	{
	Nothing,
	ChangeTag,
	ChangeEvent,
	DestroyObject,
	TriggerObject,
	ChangeCollisionSize,
	CreateTeleporter,
	CreateTrigger//,
//	ChangeMoverInitialState//,
//	ChangeSpecificSetting
	} b_MapFixCommand;
	
	var() string c_Argument1;
	var() string c_Argument2;
	var() string c_Argument3;
	var() string c_Argument4;
	var() string c_Argument5;
	var() string c_Argument6;
};

var(MapFix) config sMapFix MapFixTable[255];
var(MapFix) config bool MapFixEnabled;
var(MapFix) config bool AllowConsoleMapFix;
var bool bMapFixed;
var name TempName;

// UPLINK STUFF -------------
var UplinkControl UC;


// --------------------------

replication
{
reliable if(Role<Role_Authority)
	sSGT;
}


function PostBeginPlay()
{
//local actor Check;

local messenger m;
local LobbyControl L;
local int i;
local playerstart pt;
local playerstart pp;
local string CurrentMap;
local string CheckingMap;
local Teleporter T;

super.postbeginplay();

//check if lobby mode is enabled
if (LobbyModeEnabled && LobbyMap != "")
	{
	L = spawn(class'LobbyControl');		
	
	for (i=0;i<20;i++)
		{
		L.Endmaps[i] = Endmaps[i];
		L.LobbyMap = LobbyMap;
		}
	}	



//check the sub gametype
SetSubGametype("",true,int(subgametype)+1);
	

//create the advertising object
if (Messages[0] != "" && messagedelay != 0 && EnableMessageAdds)
	{
	m = spawn(class'Messenger');
	m.messagedelay=messagedelay;
	
	for (i=0;i<30;i++)
		{
		if (messages[i] != "")
			{
			m.messages[i] = messages[i];
			m.messageamount++;
			}
		else
			{
			break;
			}
		}	
	}	


// create uplinkcontroller
UC=spawn(class'UplinkControl');
UC.VoteEndAmount=51;

// search spawnpoint for the mega item box
foreach allactors(class'playerstart',pt)
	{
	pp=pt;
	break;
	}
spawn(class'megaitembox',,,pp.location);	
	
// make ending teleporters visable
/*
ForEach AllActors(class'Teleporter',T)
	{
	if( (InStr( T.URL, "/" ) >= 0) || (InStr( T.URL, "#" ) >= 0))
		{
		T.bHidden=false;
		}
	}
*/
}


function Timer()
{
if (!bMapFixed && MapFixEnabled)
	{
	bMapFixed=true;
	MapFixing();
	}
super.timer();
}

function name StringToName(string n)
{
SetPropertyText("TempName",n);
return TempName;
}

function MapFixing()
{
local int i;

local actor	a;

local string s1,s2,s3,s4;
local int i1,i2,i3,i4;
local float f1,f2,f3,f4;

local vector v1;
local rotator r1;


for (i=0;i<255;i++)
	{
	// nothing to do anymore, stop mapfixing
	if (MapFixTable[i].b_MapFixCommand == nothing)
		return;
	
	// if im not in the right map then i dont need to try to fix anything
	if (!IsFixingMap(i))
		break;
		
	switch MapFixTable[i].b_MapFixCommand
		{
		// change tag(s) of actor(s);
		// arg1 = tag
		// arg2 = new tag
		case ChangeTag:
			foreach allactors(class'actor',a)
				if (caps(a.tag) == caps(MapFixTable[i].c_argument1))
					a.tag = StringToName(MapFixTable[i].c_argument2);
			break;
		
		// change event(s) of actor(s);
		// arg1 = tag
		// arg2 = event
		case ChangeEvent:
			foreach allactors(class'actor',a)
				if (caps(a.tag) == caps(MapFixTable[i].c_argument1))
					a.event = StringToName(MapFixTable[i].c_argument2);
			break;
		
		// destroy actor(s)
		// arg1 = tag
		case DestroyObject:
			foreach allactors(class'actor',a)
				if (caps(a.tag) == caps(MapFixTable[i].c_argument1))
					a.Destroy();
			break;
		
		// trigger actor(s)
		// arg1 = tag			
		case TriggerObject:
			foreach allactors(class'actor',a)
				if (caps(a.tag) == caps(MapFixTable[i].c_argument1))
					a.Trigger(none,none);
			break;
		
		// change the collisionsize of (an) actor(s)
		// arg1 = tag
		// arg2 = height
		// arg3 = radius	
		case ChangeCollisionSize:
			foreach allactors(class'actor',a)
				if (caps(a.tag) == caps(MapFixTable[i].c_argument1))
					{
//					s1 = string(MapFixTable[i].c_argument2);
//					s2 = string(MapFixTable[i].c_argument3);
					a.SetCollisionSize(float(MapFixTable[i].c_argument2),float(MapFixTable[i].c_argument3));
					}
			break;	
			
		// create a teleporter
		// arg1 = tag
		// arg2 = x
		// arg3 = y
		// arg4 = z
		// arg5 = URL
		case CreateTeleporter:
			f1=float(MapFixTable[i].c_argument2);
			f2=float(MapFixTable[i].c_argument3);
			f3=float(MapFixTable[i].c_argument4);
			v1.x = f1;
			v1.y = f2;
			v1.z = f3;
			a = spawn(class'MapFixTeleporter',,,v1);
			teleporter(a).tag=StringToName(caps(MapFixTable[i].c_argument1));
			if (MapFixTable[i].c_argument5 != "")
				teleporter(a).URL=caps(MapFixTable[i].c_argument5);
			else
				teleporter(a).SetCollision(false, false, false);
			break;
			
		// create a trigger
		// arg1 = tag
		// arg2 = x
		// arg3 = y
		// arg4 = z
		// arg5 = event	
		case CreateTrigger:
			f1=float(MapFixTable[i].c_argument2);
			f2=float(MapFixTable[i].c_argument3);
			f3=float(MapFixTable[i].c_argument4);
			v1.x = f1;
			v1.y = f2;
			v1.z = f3;
			a = spawn(class'Trigger',,,v1);
			a.tag=StringToName(MapFixTable[i].c_argument1);
			a.event=StringToName(MapFixTable[i].c_argument5);
			break;	
		
/*		case ChangeMoverInitialState:
			foreach allactors(class'mover',m)
				if (caps(m.tag) == caps(MapFixTable[i].c_argument1))
					m.object.InitialState=TriggerToggle;
			break;
*/
		}
	}
}

function bool IsFixingMap(int num)
{
local string CurrentMap;
local string CheckingMap;


	CurrentMap = GetURLMap();

		if ( CurrentMap != "" )
		{
		while ( InStr(CurrentMap,"\\") > 0 )
			CurrentMap=Right(CurrentMap,InStr(CurrentMap,"\\"));
		
		if ( InStr(Caps(currentmap),".UNR") > 0 )
			Currentmap=Left(Currentmap,InStr(Caps(Currentmap),".UNR"));
		
		
			checkingmap = MapFixTable[num].a_MapName;
			
			if ( InStr(Caps(checkingmap),".UNR") > 0 )
				checkingmap=Left(checkingmap,InStr(Caps(checkingmap),".UNR"));
							
			
			if (caps(Checkingmap) == caps(CurrentMap))
				return true;
			
			return false;
		}
}



event playerpawn Login
(
	string Portal,
	string Options,
	out string Error,
	class<playerpawn> SpawnClass
)
{
	local PlayerPawn      			NewPlayer;
	local string          			InName, InPassword;
	local pawn			  			aPawn;
	local SRP2PlayerReplicationInfo NewPRI;
	local PlayerReplicationInfo		OldPRI;
	local UplinkHUD					UH;

	NewPlayer =  Super.Login(Portal, Options, Error, SpawnClass);
	if ( NewPlayer != None )
	{
		NewPRI = spawn(class'SRP2PlayerReplicationInfo');
		NewPRI.PlayerName=NewPlayer.PlayerReplicationInfo.PlayerName;
		NewPRI.PlayerID=NewPlayer.PlayerReplicationInfo.PlayerID;
		NewPRI.PlayerID2=NewPlayer.PlayerReplicationInfo.PlayerID;
		NewPRI.TeamName=NewPlayer.PlayerReplicationInfo.TeamName;
		NewPRI.Team=NewPlayer.PlayerReplicationInfo.Team;
		NewPRI.TeamID=NewPlayer.PlayerReplicationInfo.TeamID;
		NewPRI.VoiceType=NewPlayer.PlayerReplicationInfo.VoiceType;
		NewPRI.bIsABot=NewPlayer.PlayerReplicationInfo.bIsABot;
		NewPRI.bIsSpectator=NewPlayer.PlayerReplicationInfo.bIsSpectator;
		NewPRI.TalkTexture=NewPlayer.PlayerReplicationInfo.TalkTexture;
		NewPRI.PlayerZone=NewPlayer.PlayerReplicationInfo.PlayerZone;
		
		OldPRI=NewPlayer.PlayerReplicationInfo;
		NewPlayer.PlayerReplicationInfo = NewPRI;
		NewPRI.SetOwner(NewPlayer);
		OldPRI.destroy();
	
		
	
		if ( !NewPlayer.IsA('Spectator') )
		{
			NewPlayer.bHidden = false;
			NewPlayer.SetCollision(true,true,true);
			if( NewPlayer.myHUD!=none)
    			NewPlayer.myHUD.Destroy();
 			UH=Spawn(class'UplinkHUD', NewPlayer); 				
    		NewPlayer.myHUD=UH;
		}
		log("Logging in to "$Level.Title);
		if ( Level.Title ~= "The Source Antechamber" )
		{
			bSpecialFallDamage = true;
			log("reduce fall damage");
		}
	}
	return NewPlayer;
}




function AddDefaultInventory( pawn PlayerPawn )
{
	local Translator newTranslator;
	local Uplink NU;

	if ( Level.DefaultGameType != class'VRikersGame' ) 
		Super.AddDefaultInventory(PlayerPawn);

	if( PlayerPawn.IsA('Spectator') )
		return;
		
	if (PlayerPawn.FindInventoryType(class'Translator') == None)
		{
		newTranslator = Spawn(class'Translator',,, Location);
		if( newTranslator != None )
			{
			newTranslator.bHeldItem = true;
			newTranslator.GiveTo( PlayerPawn );
			PlayerPawn.SelectedItem = newTranslator;
			newTranslator.PickupFunction(PlayerPawn);
			}
		}
	if (PlayerPawn.FindInventoryType(class'Uplink') == None)
		{
		NU = Spawn(class'Uplink',,, Location);
		if( NU != None )
			{
			NU.bHeldItem = true;
			NU.GiveTo( PlayerPawn );
			PlayerPawn.SelectedItem = NU;
			NU.PickupFunction(PlayerPawn);
			NU.UC=UC;
			}
		}
}




function bool AllowsBroadcast( actor broadcaster, int Len )
{
local int i;

for (i=0;i<100;i++)
	{
//	if (MuteList[i] == none)
//		break;
	// cant do the above thing, if there would come an empty space etc...
		
	if (MuteList[i] == broadcaster)
		return false;
	}

	SentText += Len;

	return (SentText < 260);
}

function BAM( string Msg ) //BroadCastAdminMessage
{
	local Pawn P;

	for( P=Level.PawnList; P!=None; P=P.nextPawn )
		if( P.bIsPlayer && P.IsA('PlayerPawn') && PlayerPawn(P).bAdmin )
			P.ClientMessage("SRPack2: "@Msg,'RedCriticalMessage');
}

function AM(pawn pp, string Msg ) //AdminMessage
{
	local Pawn P;

	for( P=Level.PawnList; P!=None; P=P.nextPawn )
		if( P.bIsPlayer && P.IsA('PlayerPawn') && P==pp  )
			P.ClientMessage("SRPack2: "@Msg,'RedCriticalMessage');
}

function Killed(pawn killer, pawn Other, name damageType)
{
	super.Killed(killer, Other, damageType);
	if ( (Killer != None) && (Other.bIsPlayer || Other.IsA('Nali')) )
		{
		if (Other.bIsPlayer)
			{
			if (Subgametype != DeathMatch)
				killer.PlayerReplicationInfo.Score -= 2; // not in dm mode, remove points
			}
		else
			{
			killer.PlayerReplicationInfo.Score -= 2; // not in dm mode, remove points
			}
		}
}	


// Flush all modified settings, call this before resetting the subgametype...
function FlushSubGameType()
{
local scriptedpawn SP;
foreach allactors(class'ScriptedPawn',sp)
	{
	if (sp.RangedProjectile != none && sp.RangedProjectile != sp.default.RangedProjectile)
		sp.rangedprojectile = sp.default.RangedProjectile;
		
	if (sp.groundspeed != sp.default.groundspeed)
		sp.groundspeed = sp.default.groundspeed;
	if (sp.jumpz != sp.default.jumpz)
		sp.jumpz = sp.default.jumpz;
	if (sp.waterspeed != sp.default.waterspeed)
		sp.waterspeed = sp.default.waterspeed;
	}	
if (bNoFriendlyFire != default.bNoFriendlyFire)
	bNoFriendlyFire=default.bNoFriendlyFire;
}

//////////////////////////// CONSOLE COMMANDS ////////////////////////////

// mute a person
exec function Mute(int ID)
{
local Pawn P;
local int i;

For( P=Level.PawnList; P!=None; P=P.NextPawn ) 
	{ 
	if( P.IsA('PlayerPawn') && P.PlayerReplicationInfo!=None && P.PlayerReplicationInfo.PlayerID==ID ) 
		{ 
		for (i=0;i<100;i++)
			{
			if (MuteList[i] == none)
				{
				MuteList[i] = P;
				P.clientmessage("You are muted till a mapchange or if you get unmuted...",'DeathMessage');
				return;
				}
			}
		return;
		}	
	} 
//	BAM("Invalid ID...");
}

// unmute a person
exec function UnMute(int ID)
{
local Pawn P;
local int i;

For( P=Level.PawnList; P!=None; P=P.NextPawn ) 
	{ 
	if( P.IsA('PlayerPawn') && P.PlayerReplicationInfo!=None && P.PlayerReplicationInfo.PlayerID==ID ) 
		{ 
		for (i=0;i<100;i++)
			{
			if (MuteList[i] == p)
				{
				MuteList[i] = none;
				P.clientmessage("You are unmuted.",'DeathMessage');
				return;
				}
			}
		return;
		}	
	} 
//	BAM("Invalid ID...");
}


// change the subgametype
exec function SetSubGametype(string newtype,optional bool bDontShow, optional int newtype2)
{
local scriptedpawn sp;
local bool set;
	
if (!EnableSubGametypes)
	return;

if (newtype2 != 0)
	{
	switch newtype2
		{
		case 1:
			newtype="classic";
			break;
		case 2:
			newtype="rocketfrenzy";
			break;
		case 3:
			newtype="deathmatch";
			break;
		case 4:
			newtype="hardcore";
			break;
		}
	}

FlushSubGameType();
set = false;
	switch caps(newtype)
		{
		case "CLASSIC":
			// FlushSubGameType() does what needs to happen here ^_^ lol
			// only need to set the subgametype and set variable...
			SubGameType = Classic;
			set = true;
			break;
		
		case "ROCKETFRENZY":
			foreach allactors(class'ScriptedPawn',sp)
				{
				if (sp.RangedProjectile != none && sp.RangedProjectile != class'SeekingRocket')
					sp.rangedprojectile = class'SeekingRocket';
				}	
			SubGameType = RocketFrenzy;	
			set = true;
			break;
		
		case "DEATHMATCH":
			bNoFriendlyFire=false;
			SubGameType=DeathMatch;
			set=true;
			break;
			
		case "HARDCORE":
			foreach allactors(class'ScriptedPawn',sp)
				{
				if (sp.RangedProjectile != none && sp.RangedProjectile != class'HardCoreProj')
					sp.rangedprojectile = class'HardCoreProj';
				if (sp.groundspeed != 0)
					sp.groundspeed = sp.groundspeed*4;
				if (sp.jumpz != 0)
					sp.jumpz = sp.jumpz*4;
				if (sp.waterspeed != 0)
					sp.waterspeed = sp.waterspeed*4;
				}	
			SubGameType = HardCore;	
			set = true;
			break;
				
//		default:
//			playerpawn(instigator).clientmessage("Subgametype '"$newtype$"' does not exist...");	
//			break;
		}
		if (set)
			{
			if (!bDontShow)
				broadcastmessage("Subgametype '"$newtype$"' engaged!",true,'ServerMessage');
			sSGT=newtype;
			}
}

// purple boardcastmessage
exec function ServerMessage(string msg)
{
if (msg != "")
	broadcastmessage(msg,true,'ServerMessage');
}

// enable/disable ending
exec function Ending(bool b)
{
local Teleporter T;
local MapJump M;

ForEach AllActors(class'Teleporter',T)
	{
	if( InStr(T.URL,"#")>=0 || InStr(T.URL,"/")>=0 )
		{
		T.bEnabled=b;
		}
	}

ForEach AllActors(class'MapJump',M)
	{
	M.bEnabled=b;
	}
	
if (b)
	broadcastmessage("Ending has been enabled!",true,'ServerMessage');
else
	broadcastmessage("Ending has been disabled!",true,'ServerMessage');
}

// fix the map again from a console command
exec function FixMap()
{
if (!AllowConsoleMapFix)
	return;
MapFixing();
}

defaultproperties
{
				EnableSubGametypes=True
				Messages(0)="Thanks for visiting SoulReaver's, the #1 server!"
				Messages(1)="Don't forget to register on www.unrealfan.net.tc"
				Messages(2)="Mods can be downloaded at www.unrealfan.net.tc"
				Messages(3)="This server is hosted by SoulReaver"
				Messages(4)="Play fair and follow the rules, not doing this will result in kick/ban!"
				MessageDelay=160
				LobbyModeEnabled=True
				EndMaps(0)="EndGame"
				EndMaps(1)="Shrak4"
				EndMaps(2)="Invasion_6"
				LobbyMap="SR_Lobby"
				MapFixTable(0)=(a_MapName="ATApocHead",b_MapFixCommand=CreateTeleporter,c_Argument1="Modtp1",c_Argument2="1824.393188",c_Argument3="-1248.880981",c_Argument4="200.099365",c_Argument5="Modtp2")
				MapFixTable(1)=(a_MapName="ATApocHead",b_MapFixCommand=ChangeCollisionSize,c_Argument1="modtp1",c_Argument2="128",c_Argument3="160")
				MapFixTable(2)=(a_MapName="ATApocHead",b_MapFixCommand=CreateTeleporter,c_Argument1="Modtp2",c_Argument2="2205.102539",c_Argument3="-1244.312256",c_Argument4="-250.764267")
				MapFixEnabled=True
				AllowConsoleMapFix=True
				ScoreBoardType=Class'ETQ.SRpack2ScoreBoard'
				HUDType=Class'ETQ.UplinkHUD'
}
